Loading...
Searching...
No Matches
BALL::VIEW::CudaVolumeRenderer Class Reference

`#include <BALL/VIEW/RENDERING/RENDERERS/cudaVolumeRenderer.h>`

Inheritance diagram for BALL::VIEW::CudaVolumeRenderer:

## Public Member Functions

virtual bool | init (const Scene &scene)
virtual String | getRenderer () throw ()
virtual void | formatUpdated ()
virtual void | prepareBufferedRendering (const Stage &stage)
virtual void | renderToBufferImpl (FrameBufferPtr buffer)
Public Member Functions inherited from BALL::VIEW::RaytracingRenderer
virtual bool | supports (const PixelFormat &format) const
virtual Resolution | getSupportedResolution (const Resolution &min, const Resolution &max, const PixelFormat &format) const
virtual void | updateMaterialForRepresentation (Representation const *rep)=0
virtual std::vector< float > | intersectRaysWithGeometry (const std::vector< Vector3 > &origins, const std::vector< Vector3 > &directions)
Public Member Functions inherited from BALL::VIEW::BufferedRenderer
| BufferedRenderer ()
bool | setFrameBufferFormat (const FrameBufferFormat &format)
void | renderToBuffer (RenderTarget *renderTarget, const Stage &stage)
virtual void | setOffset (Size offset)
virtual void | setStride (Size stride)
Public Member Functions inherited from BALL::VIEW::Renderer
| Renderer ()
| Renderer (const Renderer &renderer)
virtual | ~Renderer ()
virtual void | clear ()
virtual bool | init (Scene &scene)
virtual bool | init (const Stage &stage, float height, float width)
virtual void | setLights (bool reset_all=false)
| Set the light sources according to the stage.
virtual void | updateCamera (const Camera *camera=0)
virtual void | updateBackgroundColor ()
| Update the background color from the stage.
virtual void | setupEnvironmentMap (const QImage &image)
| Setup an environment map.
virtual void | setupStereo (float eye_separation, float focal_length)
virtual void | useContinuousLoop (bool use_loop)
bool | isContinuous ()
virtual bool | hasFPScounter ()
virtual double | getFPS ()
virtual bool | finish ()
virtual Vector3 | mapViewportTo3D (Position x, Position y)
virtual Vector2 | map3DToViewport (const Vector3 &vec)
virtual void | pickObjects (Position x1, Position y1, Position x2, Position y2, std::list< GeometricObject * > &objects)
virtual void | getFrustum (float &near_f, float &far_f, float &left_f, float &right_f, float &top_f, float &bottom_f)
virtual bool | renderOneRepresentation (const Representation &representation)
virtual void | bufferRepresentation (const Representation &)
virtual void | removeRepresentation (const Representation &)
virtual const Stage & | getStage () const
virtual void | setStage (const Stage &stage)
bool | hasStage () const
| Test if a Stage was assigned to the Renderer.
virtual void | setSize (float width, float height)
| Set the size of the display.
virtual float | getWidth () const
virtual float | getHeight () const
virtual void | setPreviewMode (bool show_preview)
virtual void | showLightSources (bool show_light_sources)
virtual void | renderRuler ()
virtual void | setStereoMode (StereoMode state)
virtual StereoMode | getStereoMode () const
virtual void | setStereoFrustumConversion (int width_factor, int height_factor)
bool | operator== (const Renderer &) const
virtual void | render_ (const GeometricObject *object)
| Wrapper for the renderering of special GeometricObjects.

## Additional Inherited Members

Public Types inherited from BALL::VIEW::Renderer
enum | StereoMode { NO_STEREO = 0 , ACTIVE_STEREO , DUAL_VIEW_STEREO , DUAL_VIEW_DIFFERENT_DISPLAY_STEREO , TOP_BOTTOM_STEREO , INTERLACED_STEREO }
Protected Member Functions inherited from BALL::VIEW::RaytracingRenderer
virtual bool | supports (const FrameBufferFormat &format) const
Protected Member Functions inherited from BALL::VIEW::BufferedRenderer
const FrameBufferFormat & | getFrameBufferFormat () const
virtual void | renderClippingPlane_ (const ClippingPlane &)
virtual void | renderLabel_ (const Label &)
virtual void | renderLine_ (const Line &)
| Render a line.
virtual void | renderMultiLine_ (const MultiLine &)
| Render an illuminated line.
virtual void | renderMesh_ (const Mesh &)
| Render a surface mesh.
virtual void | renderPoint_ (const Point &)
| Render a single point.
virtual void | renderBox_ (const Box &)
| Render a box.
virtual void | renderSimpleBox_ (const SimpleBox &)
| Render a simple box (parallel to the axes).
virtual void | renderSphere_ (const Sphere &)
| Render a sphere.
virtual void | renderDisc_ (const Disc &)
| Render a disc.
virtual void | renderTube_ (const Tube &)
| Render a tube.
virtual void | renderTwoColoredLine_ (const TwoColoredLine &)
| Render a line with two colors.
virtual void | renderTwoColoredTube_ (const TwoColoredTube &)
| Render a tube with two colors.
virtual void | renderGridVisualisation_ (const GridVisualisation &)
| Render a grid.
virtual void | renderQuadMesh_ (const QuadMesh &)
| Render a quad mesh.
Protected Attributes inherited from BALL::VIEW::BufferedRenderer
Size | offset_
Size | stride_
Scene * | scene_
const Stage * | stage_
float | width_
float | height_
bool | show_preview_
float | volume_width_
bool | show_light_sources_
Camera | camera_
Vector3 | camera_offset_
bool | use_continuous_loop_
Size | stereo_frustum_conversion_width_
Size | stereo_frustum_conversion_height_
StereoMode | stereo_

## Detailed Description

Definition at line 16 of file cudaVolumeRenderer.h.

## Member Function Documentation

## formatUpdated()

virtual void BALL::VIEW::CudaVolumeRenderer::formatUpdated | ( |  | ) |

inline virtual

This is called once the FrameBufferFormat has been set so the renderer can perform any initialization steps that are needed.

Implements BALL::VIEW::BufferedRenderer.

Definition at line 45 of file cudaVolumeRenderer.h.

## getRenderer()

virtual String BALL::VIEW::CudaVolumeRenderer::getRenderer | ( |  | ) |
throw | ( | ) |  |  |

inline virtual

Implements BALL::VIEW::RaytracingRenderer.

Definition at line 39 of file cudaVolumeRenderer.h.

## init()

virtual bool BALL::VIEW::CudaVolumeRenderer::init | ( | const Scene & | scene | ) |

inline virtual

Exceptions

  BALL::Exception::CUDAError |

Definition at line 23 of file cudaVolumeRenderer.h.

## prepareBufferedRendering()

virtual void BALL::VIEW::CudaVolumeRenderer::prepareBufferedRendering | ( | const Stage & | stage | ) |

inline virtual

Prepare for the rendering, taking into account settings in Stage, eg. Camera, Lights, Background colors, etc.

Implements BALL::VIEW::BufferedRenderer.

Definition at line 50 of file cudaVolumeRenderer.h.

## renderToBufferImpl()

virtual void BALL::VIEW::CudaVolumeRenderer::renderToBufferImpl | ( | FrameBufferPtr | buffer | ) |

inline virtual

Render to the frame buffer.

Precondition
  The frame buffer's format is the one stored in bufferFormat and prepareBufferedRendering() has been called.

Implements BALL::VIEW::BufferedRenderer.

Definition at line 55 of file cudaVolumeRenderer.h.